#  grt4p.defn.tcl

proc {Add_GRT 4P_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]
#   set interruptlevel [fourth $addressinfo]
#   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server
 
   set i 0
   foreach ch {A B C D} {
      define-vme-register $name xVME Ch$ch.DataFiFo "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x2000 + $i]] -pro -d16 -zx"

      define-vme-register $name xVME Ch$ch.DPP_CSR  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x00 + $i]] -prw -d16 -zx -i0xf"
      for {set b 0} {$b < 16} {incr b} {
        define-vme-register $name xVME Ch$ch.DPP_CSR.b$b  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x00 + $i]] -prw -d16 -l1 -b$b -zd"
      }
      define-vme-register $name xVME Ch$ch.DPP_Wptr  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x02 + $i]] -pro -d16 -zx"
      define-vme-register $name xVME Ch$ch.DPP_Rptr  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x04 + $i]] -pro -d16 -zx"
      define-vme-register $name xVME Ch$ch.DPP_Reg4  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x06 + $i]] -prw -d16 -zx"
      define-vme-register $name xVME Ch$ch.DPP_Reg5  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x08 + $i]] -prw -d16 -zx"
      define-vme-register $name xVME Ch$ch.DPP_Reg6  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x0a + $i]] -prw -d16 -zx"

      define-vme-register $name xVME Ch$ch.ADC_Ctrl    "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1000 + $i]] -prw -d16 -zx -i0x20"
      for {set b 0} {$b < 16} {incr b} {
        define-vme-register $name xVME Ch$ch.ADC_Ctrl.b$b  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1000 + $i]] -prw -d16 -l1 -b$b -zd"
      }
      define-vme-register $name xVME Ch$ch.ADC_PreTrig "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1002 + $i]] -prw -d16 -zx -i0x20"
      define-vme-register $name xVME Ch$ch.ADC_Header  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1004 + $i]] -prw -d16 -zx"
      define-vme-register $name xVME Ch$ch.ADC_Trigger "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1006 + $i]] -prw -d16 -zx"
      define-vme-register $name xVME Ch$ch.ADC_Spare3  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1008 + $i]] -prw -d16 -zx"
      define-vme-register $name xVME Ch$ch.ADC_CFDThresh  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x100a + $i]] -prw -d16 -zx"

      define-vme-register $name xVME Ch$ch.MWD0   "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 0 + $i]] -prw -d16 -l8 -zx"
      define-vme-register $name xVME Ch$ch.MWD1   "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 2 + $i]] -prw -d16 -l8 -zx"
      define-vme-register $name xVME Ch$ch.MWD2   "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 4 + $i]] -prw -d16 -l16 -zx"
      define-vme-register $name xVME Ch$ch.MWD3   "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 6 + $i]] -prw -d16 -l16 -zx"
      define-vme-register $name xVME Ch$ch.MWD4   "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 8 + $i]] -prw -d16 -l8 -zx"
      define-vme-register $name xVME Ch$ch.MWD5   "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 10 + $i]] -prw -d16 -l8 -zx"
      define-vme-register $name xVME Ch$ch.MWD6   "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 12 + $i]] -prw -d16 -l16 -zx"
      define-vme-register $name xVME Ch$ch.MWD7   "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 14 + $i]] -prw -d16 -l16 -zx"
      define-vme-register $name xVME Ch$ch.MWD8   "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 16 + $i]] -prw -d16 -l8 -zx"
      define-vme-register $name xVME Ch$ch.MWD9   "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 18 + $i]] -prw -d16 -l5 -zx"
      define-vme-register $name xVME Ch$ch.MWD10  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 20 + $i]] -prw -d16 -l2 -zx"
      define-vme-register $name xVME Ch$ch.MWD11  "-a$A32addrbase -w32 -o[format "0x%x" [expr 0x1800 + 20 + $i]] -prw -d16 -l16 -zx"

 
      define-vme-register $name generic Ch$ch.MWDPclkfreq  "-n[set name]_Ch[set ch].MWDPclkfreq -tstring"
      define-vme-register $name generic Ch$ch.MWDPdecfact  "-n[set name]_Ch[set ch].MWDPdecfact -tstring"
      define-vme-register $name generic Ch$ch.MWDPshptime  "-n[set name]_Ch[set ch].MWDPshptime -tstring"
      define-vme-register $name generic Ch$ch.MWDPtrapwid  "-n[set name]_Ch[set ch].MWDPtrapwid -tstring"
      define-vme-register $name generic Ch$ch.MWDPpeaksep  "-n[set name]_Ch[set ch].MWDPpeaksep -tstring"
      define-vme-register $name generic Ch$ch.MWDPdecaytc  "-n[set name]_Ch[set ch].MWDPdecaytc -tstring"
      define-vme-register $name generic Ch$ch.MWDPpeakstm  "-n[set name]_Ch[set ch].MWDPpeakstm -tstring"
      define-vme-register $name generic Ch$ch.MWDPbaseutm  "-n[set name]_Ch[set ch].MWDPbaseutm -tstring"
      define-vme-register $name generic Ch$ch.MWDPbaseave  "-n[set name]_Ch[set ch].MWDPbaseave -tstring"
      define-vme-register $name generic Ch$ch.MWDPmode     "-n[set name]_Ch[set ch].MWDPmode -tstring"
   

      incr i 0x4000
   }
}


proc {GRT 4P_registers} {} {
    global registers_table

    set registers_table   {}

    foreach c {A B C D} {
        lappend registers_table [list "Channel $c Data FIFO"  Ch$c.DataFiFo]
        lappend registers_table [list "Channel $c DPP CSR"  Ch$c.DPP_CSR]
        lappend registers_table [list "Channel $c DPP Write Pointer"  Ch$c.DPP_Wptr]
        lappend registers_table [list "Channel $c DPP Read Pointer"  Ch$c.DPP_Rptr]
        for {set i 4} {$i <= 6} {incr i} {
            lappend registers_table [list "Channel $c DPP Reg$i"   Ch$c.DPP_Reg$i]
        }
        lappend registers_table [list "Channel $c ADC CTRL"  Ch$c.ADC_Ctrl]
        lappend registers_table [list "Channel $c ADC Pretrig"  Ch$c.ADC_PreTrig]
        lappend registers_table [list "Channel $c ADC Header"  Ch$c.ADC_Header]
        lappend registers_table [list "Channel $c ADC Trigger" Ch$c.ADC_Trigger]
        lappend registers_table [list "Channel $c ADC Spare3"  Ch$c.ADC_Spare3]
        lappend registers_table [list "Channel $c ADC CFDThresh"  Ch$c.ADC_Spare4]
        for {set i 0} {$i <= 10} {incr i} {
            lappend registers_table [list "Channel $c MWD Reg$i"   Ch$c.MWD$i]
        }
 
       lappend registers_table [list "Channel $c MWDP clkfreq"  Ch$c.MWDPclkfreq]
       lappend registers_table [list "Channel $c MWDP decfact"  Ch$c.MWDPdecfact]
       lappend registers_table [list "Channel $c MWDP shptime"  Ch$c.MWDPshptime]
       lappend registers_table [list "Channel $c MWDP trapwid"  Ch$c.MWDPtrapwid]
       lappend registers_table [list "Channel $c MWDP peaksep"  Ch$c.MWDPpeaksep]
       lappend registers_table [list "Channel $c MWDP decaytc"  Ch$c.MWDPdecaytc]
       lappend registers_table [list "Channel $c MWDP peakstm"  Ch$c.MWDPpeakstm]
       lappend registers_table [list "Channel $c MWDP baseutm"  Ch$c.MWDPbaseutm]
       lappend registers_table [list "Channel $c MWDP baseave"  Ch$c.MWDPbaseave]
       lappend registers_table [list "Channel $c MWDP mode"  Ch$c.MWDPmode]
    }
}


proc {GRT 4P_DAQ-reset} {args} {
#   grt4p
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
#    soft reset
#    foreach c {A B C D} {
#        set ctrl [expr [read-vme-register $module.Ch$c.ADC_Ctrl] & 0xfe]
#	    write-vme-register $module.Ch$c.ADC_Ctrl [expr $ctrl + 1]
#	    write-vme-register $module.Ch$c.ADC_Ctrl [expr $ctrl + 0]
#    }
    write-vme-registers $module.Ch\[A-D\].ADC_Ctrl.b0 1
    write-vme-registers $module.Ch\[A-D\].ADC_Ctrl.b0 0
    set m [second [split $module #]]
    write-vme-register $module.ChA.ADC_Header  [expr (($m << 2) + 0) << 8]
    write-vme-register $module.ChB.ADC_Header  [expr (($m << 2) + 1) << 8]
    write-vme-register $module.ChC.ADC_Header  [expr (($m << 2) + 2) << 8]
    write-vme-register $module.ChD.ADC_Header  [expr (($m << 2) + 3) << 8]
}

proc {GRT 4P_DAQ-go} {args} {
#   grt4p
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    foreach c {A B C D} {
	set csr [read-vme-register $module.Ch$c.DPP_CSR]
#	set ctrl [expr [read-vme-register $module.Ch$c.ADC_Ctrl] & 0xfd]
	if {[expr $csr & 0x80] != 0x80} {
#	    write-vme-register $module.Ch$c.ADC_Ctrl [expr $ctrl + 2]
	    write-vme-register $module.Ch$c.ADC_Ctrl.b1 1
	} else {
#           write-vme-register $module.Ch$c.ADC_Ctrl $ctrl
	    write-vme-register $module.Ch$c.ADC_Ctrl.b1 0
	}
    }
}

proc {GRT 4P_DAQ-halt} {args} {
#   grt4p
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    foreach c {A B C D} {
        write-vme-register $module.Ch$c.ADC_Ctrl.b1 0
    }
}

proc {GRT 4P_DAQ-setup} {args} {
#   grt4p
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
#    soft reset
#    foreach c {A B C D} {
#        set ctrl [expr [read-vme-register $module.Ch$c.ADC_Ctrl] & 0xfe]
#	    write-vme-register $module.Ch$c.ADC_Ctrl [expr $ctrl + 1]
#	    write-vme-register $module.Ch$c.ADC_Ctrl [expr $ctrl + 0]
#    }
    write-vme-registers $module.Ch\[A-D\].ADC_Ctrl.b0 1
    write-vme-registers $module.Ch\[A-D\].ADC_Ctrl.b0 0
    initialise-vme-registers $module.Ch\[A-D\].DPP_CSR
    initialise-vme-registers $module.Ch\[A-D\].ADC_PreTrig
    initialise-vme-registers $module.Ch\[A-D\].ADC_Ctrl
    write-vme-registers $module.Ch\[A-D\].DPP_Reg5 0xef
    set m [second [split $module #]]
    write-vme-register $module.ChA.ADC_Header  [expr (($m << 2) + 0) << 8]
    write-vme-register $module.ChB.ADC_Header  [expr (($m << 2) + 1) << 8]
    write-vme-register $module.ChC.ADC_Header  [expr (($m << 2) + 2) << 8]
    write-vme-register $module.ChD.ADC_Header  [expr (($m << 2) + 3) << 8]

   foreach ch {A B C D} {
    write-vme-register $module.Ch$ch.MWDPclkfreq 80.0  
    write-vme-register $module.Ch$ch.MWDPdecfact 16
    write-vme-register $module.Ch$ch.MWDPshptime 6.0
    write-vme-register $module.Ch$ch.MWDPtrapwid 4.4
    write-vme-register $module.Ch$ch.MWDPpeaksep 8.5
    write-vme-register $module.Ch$ch.MWDPdecaytc 50.0
    write-vme-register $module.Ch$ch.MWDPpeakstm 7.2
    write-vme-register $module.Ch$ch.MWDPbaseutm 2.0
    write-vme-register $module.Ch$ch.MWDPbaseave 4
    write-vme-register $module.Ch$ch.MWDPmode 0

    write-vme-register $module.Ch$ch.MWD0 227
    write-vme-register $module.Ch$ch.MWD1 233
    write-vme-register $module.Ch$ch.MWD2 576
    write-vme-register $module.Ch$ch.MWD3 214
    write-vme-register $module.Ch$ch.MWD4 4
    write-vme-register $module.Ch$ch.MWD5 10
    write-vme-register $module.Ch$ch.MWD6 16384
    write-vme-register $module.Ch$ch.MWD7 63239
    write-vme-register $module.Ch$ch.MWD8 0
    write-vme-register $module.Ch$ch.MWD9 17
    write-vme-register $module.Ch$ch.MWD10 0

   }
}

#   for parameter save/restore
set {GRT 4P_registersavepatterns} \
  {Ch\[A-D\].DPP_CSR Ch\[A-D\].ADC_PreTrig Ch\[A-D\].ADC_Trigger Ch\[A-D\].ADC_Ctrl Ch\[A-D\].ADC_CFDThresh Ch\[A-D\].MWD*}




