

proc Set_GRT_Options {} {}

proc Dump_Raw_VME_Data_GRT {} {return ""}

proc define_GRT_config {} {
    global VMEserver

   set maxmodule [inform vmecontrol inquire grt4pcount]
   if {[string length $maxmodule] > 2} {set maxmodule 0}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set VMEserver [inform vmecontrol VMEmodule2server grt4p#$i]
      set z [catch {eg "(register :name '/$VMEserver/grt4p#$i.ChA.DPP_CSR'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register grt4p#$i.ChA.DPP_CSR"
          clear-footer
          error $m
      }
      DefineConfig "4 $i [string range [first $m] 2 end]"
   }
}

proc create_GRT_spectra {} {
    global SpectrumServer 
    global UCL

#   for the GRP 4 channel module

   set ADCs [list A B C D]

   set maxmodule [inform vmecontrol inquire grt4pcount]
   if {[string length $maxmodule] > 2} {set maxmodule 0}
   set maxadc 4

   for {set i 1} {$i <= $maxmodule} {incr i} {

    set VMEserver [inform vmecontrol VMEmodule2server grt4p#$i]
    
    for {set j 0} {$j < $maxadc} {incr j} {

#    histogram used to display the digital trace
#    need to obtain trace length from the board

      set z [catch {eg "(register :name '/$VMEserver/grt4p#$i.Ch[lindex $ADCs $j].DPP_Reg6'  ?value)" } vl]
      if {$z!=0} then {set vl 512}      ;# use default 
      if {$vl==0} then {set vl 512}     ;# use default

      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range [expr $vl - 2] :name 'grt4p#$i.adc$j' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum grt4p#$i.adc$j"
          clear-footer
          error $m
      } else {
          map_spectrum  "grt4p#$i.adc$j [expr 256 + $j + ($i * 4)] 0 0 0"
      }

#    histograms for the computed energy 

if {$UCL != 0} then {return}   ;# UCL processor does not have enough memory

      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 65536 :name 'grt4p#$i.E[set j]L' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum grt4p#$i.E[set j]L"
          clear-footer
          error $m
      } else {
          map_spectrum  "grt4p#$i.E[set j]L [expr $j + ($i * 4)] 0 0 0"         ;#  item 0
      }

      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 65536 :name 'grt4p#$i.E[set j]H' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum grt4p#$i.E[set j]H"
          clear-footer
          error $m
      } else {          
          map_spectrum  "grt4p#$i.E[set j]H [expr $j + ($i * 4)] 1 0 0"        ;#  item 1
      }
     }
    }
}

